% TEST 1, visualization of convergence of Fn as the number of different fields increases:
% the best net is the best on the most interrogation windows it will process

% LOAD DATA FROM test1_sameTrueField

% choice a unic number of image particles for each field in
% test1_sameTrueField to launch the present script succesfully

% this scripts needs fn=[row x columns]=[different fields x different networks]


clear
%close all
clc


load 3nip_10fields_1nets

ig3_sel_v=1:10;%, 100:100:1000]; % how many different fields to compute the mean error?

fn_compl_mean=zeros(length(ig3_sel_v),size(fn_compl,2));
fn_nocurv_mean=fn_compl_mean;

for i=1:length(ig3_sel_v)
    
    ig3_sel=ig3_sel_v(i);
    
    fn_compl_mean(i,:)=mean(fn_compl(1:ig3_sel,:),1);
    fn_nocurv_mean(i,:)=mean(fn_nocurv(1:ig3_sel,:),1);
    
end


figure
for i=1:size(fn_compl,2)
    subplot(1,2,1)
    hold on
    p=plot(ig3_sel_v,fn_compl_mean(:,i));
    p.Marker='*';
    xlabel('number of different fields')
    ylabel('Frobenius norm')
    title('complete fields')
    grid on
    %axis([1,max(ig3_sel_v), 0,max([max(max(fn_compl_mean)),max(max(fn_nocurv_mean))])])
    xticks([1,200:200:1000])
    
    subplot(1,2,2)
    hold on
    p=plot(ig3_sel_v,fn_nocurv_mean(:,i));
    p.Marker='*';
    xlabel('number of different fields')
    ylabel('Frobenius norm')
    title('fields without curvature')
    grid on
    %axis([1,max(ig3_sel_v), 0,max([max(max(fn_compl_mean)),max(max(fn_nocurv_mean))])])
    xticks([1,200:200:1000])

end

legend('nocurv 1e06 200 06','nocurv 4e05 100 08','nocurv 1e06 100 06','compl 1e06 100 09','compl 4e05 100 12','nocurv+compl 1e06 100+100 09', 'location','southWest');





