
% TEST 1:

% INPUT: load particle images and target from image_generator3 (ig3)
 
% 1) choice number of different velocity fields (matfiles from ig3)
% 2) choice number of image pairs for the same field
% 3) choice trained networks
% 4) run
% 5) see results of 2)
% 6) load data to test1_choiceNet to see results of 1)

           
clear
%close all
clc

%% TRAINING DATA, OVERVIEW
% load uguali_ig3_500_withnoise_manuale_rhocost_div255_dec5_umd
% Vfin=Vfint(:,1:6);
% mean_dtrain=mean(Vfin,1)
% max_dtrain=max(Vfin)
% min_dtrain=min(Vfin)
% std_dtrain=std(Vfin,1)
%sort(Vfin,1)

%% LOAD DATA
net_name=[
    "trained_net_1mlx2",...
    "trained_net_nocurv08",...
    "trained_net_nocurv06_1milione",...
    "trained_net_1milione_13806_009",...
    "trained_net_prime100ep_11603_lr1e05",...
    "trained_net_nc_c_1ml"];

%net_name=["trained_net_1mlx2"];

%% how many?
nip_v=[1,100:100:1000]; % how many particle images (rows of variables in matfile) to compute the mean? 
ig3_tot=1; % how many different fields (.mat files from ig3) to compute the mean ? 

upred_means=zeros(ig3_tot,32,32);
vpred_means=zeros(ig3_tot,32,32);
intpred_means=zeros(ig3_tot,32,32);

%% initialize errors
fn_compl=zeros(ig3_tot,length(net_name),length(nip_v));
fn_nocurv=fn_compl;

rmseu_compl=fn_compl;
rmseu_nocurv=fn_compl;

rmsev_compl=fn_compl;
rmsev_nocurv=fn_compl;

biasu_compl=fn_compl;
biasu_nocurv=fn_compl;

biasv_compl=fn_compl;
biasv_nocurv=fn_compl;



%%
for cnn=1:length(net_name) % for each network
    load(net_name(cnn))
    net_name(cnn)

    for ig3_number=1:ig3_tot % for each velocity field, per studio di convergenza sui campi diversi

        %for ig3_number=1 % per studio convergenza del numero di particle images
        ig3=append('ig3_1000_withnoise_manuale_rhocost_div255_dec5_umd_uguali_',num2str(ig3_number)); % load data
        load(ig3)
        %load ig3_10000_withnoise_manuale_rhocost_div255_dec5_umd_uguali_1
        
        Ifin1=Ifin1([601:end,1:600],:,:);
        Ifin2=Ifin2([601:end,1:600],:,:);
        Vfint=Vfint([601:end,1:600],:);
        
        for nf=1:length(nip_v) % for each group of image pairs
            nip=nip_v(nf);

            Ifin1x=Ifin1(1:nip,:,:);
            Ifin2x=Ifin2(1:nip,:,:);

            XTest=zeros(size(Ifin1x,1),size(Ifin1x,2),size(Ifin1x,3),2);
            XTest(:,:,:,1)=Ifin1x; 
            XTest(:,:,:,2)=Ifin2x; 
            XTest=permute(XTest, [2 3 4 1]); % [resx, resy, channel, number of image pairs]

            YTest=Vfint(1:nip,1:6);

%% ACCURACY EVALUATION
YPred=predict(net, XTest);

%% RECONSTRUCTION OF VELOCITY FIELDS
x=-15.5:1:15.5;
y=15.5:-1:-15.5;

upred=zeros(size(Ifin1x,1),size(Ifin1x,2), size(Ifin1x,3));
vpred=upred;
ureal=upred;
vreal=upred;
urnc=upred;
vrnc=upred;

abserr_u=upred;
abserr_v=upred;
rmse=upred;

int_p=zeros(size(Ifin1x,2), size(Ifin1x,3)); % auxiliary variable
int_r=int_p; % auxiliary variable
int_rnc=int_p; % auxiliary variable

for k=1:size(YPred,1)
upredf= @(xx,yy) YPred(k,1)+YPred(k,[3,4])*[xx;yy]; % predicted velocity field
vpredf= @(xx,yy) YPred(k,2)+YPred(k,[5,6])*[xx;yy];

urealf= @(xx,yy) Vfint(k,1)+Vfint(k,[3,4])*[xx;yy]+[xx,yy]*[Vfint(k,7:8);Vfint(k,9:10)]*[xx;yy];
vrealf= @(xx,yy) Vfint(k,2)+Vfint(k,[5,6])*[xx;yy]+[xx,yy]*[Vfint(k,11:12);Vfint(k,13:14)]*[xx;yy];

urncf= @(xx,yy) Vfint(k,1)+Vfint(k,[3,4])*[xx;yy];
vrncf= @(xx,yy) Vfint(k,2)+Vfint(k,[5,6])*[xx;yy];

for i=1:length(x)
    for j=1:length(y)
upred(k,j,i)=upredf(x(i),y(j));
vpred(k,j,i)=vpredf(x(i),y(j));

ureal(k,j,i)=urealf(x(i),y(j));
vreal(k,j,i)=vrealf(x(i),y(j));

urnc(k,j,i)=urncf(x(i),y(j));
vrnc(k,j,i)=vrncf(x(i),y(j));
    end
end
end

% ureal=squeeze(ureal(1,:,:));
% vreal=squeeze(vreal(1,:,:));
% urnc=squeeze(urnc(1,:,:));
% vrnc=squeeze(vrnc(1,:,:));

int_pred=sqrt(upred.^2+vpred.^2);
int_real=sqrt(ureal.^2+vreal.^2);
int_realnc=sqrt(urnc.^2+vrnc.^2);

%% VISUALIZATION OF VELOCITY FIELDS
% for k=1:size(Vfint,1)
%     
%     % predicted direction
%     up(:,:)=upred(k,:,:); % auxiliary variable
%     vp(:,:)=vpred(k,:,:); % auxiliary variable
%     figure('units','normalized','outerposition',[0 0 1 1])
%     subplot(2,3,1)
%     quiver(x, y, up(:,:), vp(:,:))
%     xlabel('x [px]')
%     ylabel('y [px]')
%     axis([min(x),max(x),min(y), max(y)])
%     title('Prediction, direction')
%        
%     % real without curvature direction
%     up(:,:)=urnc(k,:,:);
%     vp(:,:)=vrnc(k,:,:);
%     subplot(2,3,2)
%     quiver(x, y, up(:,:), vp(:,:))
%     xlabel('x [px]')
%     ylabel('y [px]')
%     axis([min(x),max(x),min(y), max(y)])
%     title('True field without curvature, direction')
%     
%     % real direction
%     up(:,:)=ureal(k,:,:);
%     vp(:,:)=vreal(k,:,:);
%     subplot(2,3,3)
%     quiver(x, y, up(:,:), vp(:,:))
%     xlabel('x [px]')
%     ylabel('y [px]')
%     axis([min(x),max(x),min(y), max(y)])
%     title('True field, direction')
%     
%     int_p(:,:)=int_pred(k,:,:);
%     int_r(:,:)=int_real(k,:,:);
%     int_rnc(:,:)=int_realnc(k,:,:);
%     
%     bottom = min([min(min(int_p)),min(min(int_r)),min(min(int_rnc))]);
%     top  = max([max(max(int_p)),max(max(int_r)), max(max(int_rnc))]);
%     
%     % predicted intensity
%     subplot(2,3,4)
%     contourf(x,y,int_p)
%     xlabel('x [px]')
%     ylabel('y [px]')
%     axis([min(x),max(x),min(y), max(y)])
%     title('Prediction, intensity')
%     caxis manual
%     caxis([bottom top]);
%     colorbar
% 
%     % true without curvature, intensity
%     subplot(2,3,5)
%     contourf(x,y,int_rnc)
%     xlabel('x [px]')
%     ylabel('y [px]')
%     axis([min(x),max(x),min(y), max(y)])
%     title('True field without curvature, intensity')
%     caxis manual
%     caxis([bottom top]);
%     colorbar
%     
%     % true intensity
%     subplot(2,3,6)
%     contourf(x,y,int_r)
%     xlabel('x [px]')
%     ylabel('y [px]')
%     axis([min(x),max(x),min(y), max(y)])
%     title('True field, intensity')
%     %title(['True field, intensity' num2str(int_r(15,15))])
%     caxis manual
%     caxis([bottom top]);
%     colorbar
% end

%% MEAN FIELD

upred_mean=squeeze(mean(upred,1)); % same velocity field and different particle images
vpred_mean=squeeze(mean(vpred,1));
intpred_mean=sqrt(upred_mean.^2+vpred_mean.^2);


%% VISUALIZATION OF MEAN FIELD
% figure('units','normalized','outerposition',[0 0 1 1]);
% title('mean image')
% 
% %predicted direction
% subplot(2,3,1)
% quiver(x, y, upred_mean, vpred_mean)
% xlabel('x [px]')
% ylabel('y [px]')
% axis([min(x),max(x),min(y),max(y)])
% title('mean prediction, direction')
% grid on
% 
% % true without curvature direction
% subplot(2,3,2)
% quiver(x,y,urnc,vrnc)
% xlabel('x [px]')
% ylabel('y [px]')
% axis([min(x),max(x),min(y),max(y)])
% title('True field n c, direction')
% grid on
% 
% % true direction
% subplot(2,3,3)
% quiver(x,y,ureal,vreal)
% xlabel('x [px]')
% ylabel('y [px]')
% axis([min(x),max(x),min(y),max(y)])
% title('True field, direction')
% grid on
% 
% bottom=min(min(min(intpred_mean)),min(min(min(int_real))));
% top=max(max((max(intpred_mean))),max(max(max(int_real))));
% 
% % predicted intensity
% 
% subplot(2,3,4)
% contourf(x,y,intpred_mean)
% xlabel('x [px]')
% ylabel('y [px]')
% axis([min(x),max(x),min(y),max(y)])
% title('mean prediction, intensity')
% caxis manual
% caxis([bottom top]);
% colorbar
% grid on
% 
% % true intensity without curvature
% subplot(2,3,5)
% contourf(x,y,int_realnc)
% xlabel('x [px]')
% ylabel('y [px]')
% axis([min(x),max(x),min(y),max(y)])
% title('True field n c, intensity')
% caxis manual
% caxis([bottom top]);
% colorbar
% grid on
% 
% % true intensity
% subplot(2,3,6)
% contourf(x,y,int_real)
% xlabel('x [px]')
% ylabel('y [px]')
% axis([min(x),max(x),min(y),max(y)])
% title('True field, intensity')
% caxis manual
% caxis([bottom top]);
% colorbar
% grid on


%% ERRORS ON MEAN FIELD
N=32*32;

ureal=squeeze(ureal(1,:,:));
vreal=squeeze(vreal(1,:,:));
urnc=squeeze(urnc(1,:,:));
vrnc=squeeze(vrnc(1,:,:));

fn_compl(ig3_number,cnn,nf)=sqrt(1/N*sum(sum((upred_mean-ureal).^2+(vpred_mean-vreal).^2))); % frobenius norm
rmseu_compl(ig3_number,cnn,nf)=sqrt(1/N*sum(sum(upred_mean-ureal).^2));
rmsev_compl(ig3_number,cnn,nf)=sqrt(1/N*sum(sum(vpred_mean-vreal).^2));
biasu_compl(ig3_number,cnn,nf)=1/N*sqrt(sum(sum(abs(upred_mean-ureal))));
biasv_compl(ig3_number,cnn,nf)=1/N*sqrt(sum(sum(abs(vpred_mean-vreal))));

fn_nocurv(ig3_number,cnn,nf)=sqrt(1/N*sum(sum((upred_mean-urnc).^2+(vpred_mean-vrnc).^2)));
rmseu_nocurv(ig3_number,cnn,nf)=sqrt(1/N*sum(sum(upred_mean-urnc).^2));
rmsev_nocurv(ig3_number,cnn,nf)=sqrt(1/N*sum(sum(vpred_mean-vrnc).^2));
biasu_nocurv(ig3_number,cnn,nf)=1/N*sqrt(sum(sum(abs(upred_mean-urnc))));
biasv_nocurv(ig3_number,cnn,nf)=1/N*sqrt(sum(sum(abs(vpred_mean-vrnc))));


%%
name=sprintf('test1_%d_%s', nip, net_name(cnn));
save(name, 'upred', 'vpred')

        end
        
        
    end
    
end

%%
name=sprintf('%dnip_%dfields_%dnets', nip_v(end), ig3_tot,length(net_name));
save(name,'fn_compl','fn_nocurv','rmseu_compl','rmseu_nocurv','rmsev_compl','rmsev_nocurv','biasu_compl','biasu_nocurv','biasv_compl','biasv_nocurv','nip_v','net_name')
 

%% CONVERGENCE OF ERRORS AS NIP INCREASES (FN, RMSE, BIAS)
figure

for i=1:length(net_name)
    subplot(1,2,1)
    hold on
    p=plot(nip_v,squeeze(fn_compl(1,i,:)));
    p.Marker='*';
    xlabel('number of particle images')
    ylabel('Frobenius norm')
    grid on
    title('complete field')
    xticks(nip_v(1:2:end))
    axis([1,max(nip_v),0,max([max(max(squeeze(fn_compl(1,:,:)))),max(max(squeeze(fn_nocurv(1,:,:))))])])

    subplot(1,2,2)
    hold on
    p=plot(nip_v,squeeze(fn_nocurv(1,i,:)));
    p.Marker='*';
    xlabel('number of particle images')
    ylabel('Frobenius norm')
    grid on
    title('field without curvature')
    axis([1,max(nip_v),0,max([max(max(squeeze(fn_compl(1,:,:)))),max(max(squeeze(fn_nocurv(1,:,:))))])])
    xticks(nip_v(1:2:end))

end
legend('nocurv 1e06 200 06','nocurv 4e05 100 08','nocurv 1e06 100 06','compl 1e06 100 09','compl 4e05 100 12','nocurv+compl 1e06 100+100 09', 'location','northEast');

figure
for i=1:length(net_name)
    subplot(1,2,1)
    hold on
    p=plot(nip_v,squeeze(rmseu_compl(1,i,:)));
    p.Marker='*';
    xlabel('number of particle images')
    ylabel('RMSE(u)')
    grid on
    title('complete field')
    axis([1,max(nip_v),0,max([max(max(squeeze(rmseu_compl(1,:,:)))),max(max(squeeze(rmseu_nocurv(1,:,:))))])])
    xticks(nip_v(1:2:end))
    
    subplot(1,2,2)
    hold on
    p=plot(nip_v,squeeze(rmseu_nocurv(1,i,:)));
    p.Marker='*';
    xlabel('number of particle images')
    ylabel('RMSE(u)')
    grid on
    title('field without curvature')
    axis([1,max(nip_v),0,max([max(max(squeeze(rmseu_compl(1,:,:)))),max(max(squeeze(rmseu_nocurv(1,:,:))))])])
    xticks(nip_v(1:2:end))

end
legend('nocurv 1e06 200 06','nocurv 4e05 100 08','nocurv 1e06 100 06','compl 1e06 100 09','compl 4e05 100 12','nocurv+compl 1e06 100+100 09', 'location','northEast');

figure
for i=1:length(net_name)
    subplot(1,2,1)
    hold on
    p=plot(nip_v(1:end),squeeze(rmsev_compl(1,i,1:end)));
    p.Marker='*';
    xlabel('number of particle images')
    ylabel('RMSE(v)')
    grid on
    title('complete field')
    axis([1,max(nip_v),0,max([max(max(squeeze(rmsev_compl(1,:,:)))),max(max(squeeze(rmsev_nocurv(1,:,:))))])])
    xticks(nip_v(1:2:end))

    subplot(1,2,2)
    hold on
    p=plot(nip_v,squeeze(rmsev_nocurv(1,i,:)));
    p.Marker='*';
    xlabel('number of particle images')
    ylabel('RMSE(v)')
    grid on
    title('field without curvature')
    axis([1,max(nip_v),0,max([max(max(squeeze(rmsev_compl(1,:,:)))),max(max(squeeze(rmsev_nocurv(1,:,:))))])])
    xticks(nip_v(1:2:end))

end
legend('nocurv 1e06 200 06','nocurv 4e05 100 08','nocurv 1e06 100 06','compl 1e06 100 09','compl 4e05 100 12','nocurv+compl 1e06 100+100 09', 'location','northEast');

figure
for i=1:length(net_name)
    subplot(1,2,1)
    hold on
    p=plot(nip_v,squeeze(biasu_compl(1,i,:)));
    p.Marker='*';
    xlabel('number of particle images')
    ylabel('bias(u)')
    grid on
    title('complete field')
    axis([1,max(nip_v),0,max([max(max(squeeze(biasu_compl(1,:,:)))),max(max(squeeze(biasu_nocurv(1,:,:))))])])
    xticks(nip_v(1:2:end))

    subplot(1,2,2)
    hold on
    p=plot(nip_v,squeeze(biasu_nocurv(1,i,:)));
    p.Marker='*';
    xlabel('number of particle images')
    ylabel('bias(u)')
    grid on
    title('field without curvature')
    axis([1,max(nip_v),0,max([max(max(squeeze(biasu_compl(1,:,:)))),max(max(squeeze(biasu_nocurv(1,:,:))))])])
    xticks(nip_v(1:2:end))

end
legend('nocurv 1e06 200 06','nocurv 4e05 100 08','nocurv 1e06 100 06','compl 1e06 100 09','compl 4e05 100 12','nocurv+compl 1e06 100+100 09', 'location','northEast');

figure
for i=1:length(net_name)
    subplot(1,2,1)
    hold on
    p=plot(nip_v(1:end),squeeze(biasv_compl(1,i,1:end)));
    p.Marker='*';
    xlabel('number of particle images')
    ylabel('bias(v)')
    grid on
    title('complete field')
    axis([1,max(nip_v),0,max([max(max(squeeze(biasv_compl(1,:,:)))),max(max(squeeze(biasv_nocurv(1,:,:))))])])
    xticks(nip_v(1:2:end))

    subplot(1,2,2)
    hold on
    p=plot(nip_v,squeeze(biasv_nocurv(1,i,:)));
    p.Marker='*';
    xlabel('number of particle images')
    ylabel('bias(v)')
    grid on
    title('field without curvature')
    axis([1,max(nip_v),0,max([max(max(squeeze(biasv_compl(1,:,:)))),max(max(squeeze(biasv_nocurv(1,:,:))))])])
    xticks(nip_v(1:2:end))

end
legend('nocurv 1e06 200 06','nocurv 4e05 100 08','nocurv 1e06 100 06','compl 1e06 100 09','compl 4e05 100 12','nocurv+compl 1e06 100+100 09', 'location','northEast');


%% QUALITATIVE IMPROVEMENTS AS NIP INCREASES

% figure
% 
% bottom=min([min(min(min(intpred_means))),min(min(min(int_real))),min(min(min(int_realnc)))]);
% top=max([max(max(max(intpred_means))),max(max(max(int_real))),max(max(max(int_realnc)))]);
% 
% for i=1:size(intpred_means,1)
%     subplot(2,4,i+4)
%     contourf(x,y,squeeze(intpred_means(i,:,:)))
%     xlabel('x [px]')
%     ylabel('y [px]')
%     title(['mean on ',num2str(nip_v(i)), ' images'])
%     axis([min(x),max(x),min(y),max(y)])
%     caxis manual
%     caxis([bottom top]);
%     colorbar
%     grid on
% end
% 
% subplot(2,4,2)
%     contourf(x,y,int_realnc)
%     xlabel('x [px]')
%     ylabel('y [px]')
%     title('true field without curvature')
%     axis([min(x),max(x),min(y),max(y)])
%     caxis manual
%     caxis([bottom top]);
%     colorbar
%     grid on
%     
% subplot(2,4,3)
%     contourf(x,y,int_real)
%     xlabel('x [px]')
%     ylabel('y [px]')
%     title('true field')
%     axis([min(x),max(x),min(y),max(y)])
%     caxis manual
%     caxis([bottom top]);
%     colorbar
%     grid on

%% save errors for future plots

%save('10000data_convergence_6networks', 'nip_v','net_name','fn_compl','fn_nocurv','rmseu_compl','rmseu_nocurv','rmsev_compl','rmsev_nocurv','biasu_compl','biasu_nocurv','biasv_compl','biasv_nocurv')

