% output: Ifin1, Ifin2, ufin, vfin

n_imagepairs=1;
dec=4; % significant decimals
extrapx=4; % number of pixels beyond each boundary (particles are allowed to leave/enter the camera field of view)

resx=1000; % image resolution x [px]
resy=500; % image resolution along y
xmax=2*extrapx+resx; % image resolution along x before cropping
ymax=2*extrapx+resy; % image resolution along y before cropping

xvf=-xmax/2+0.5:1:xmax/2-0.5; % pixels along x (x axis: sx->dx)
yvf=ymax/2-0.5:-1:-ymax/2+0.5;% pixels along y (y axis: down->top)
[XVF, YVF]=meshgrid(xvf, yvf);

rho=0.029; %[ppp] 
n_particles=round(rho*xmax*ymax);% number of particles before cropping


%XVFnp=XVF.*ones(xmax,ymax,n_particles);
%XVFnp=permute(XVFnp,[3,1,2]);

%YVFnp=YVF.*ones(xmax,ymax,n_particles);
%YVFnp=permute(YVFnp,[3,1,2]);


Ifin1=zeros(n_imagepairs,resy,resx);
Ifin2=zeros(n_imagepairs,resy,resx);

%% 2D VELOCITY FIELD: RANKINE VORTEX WITH SHEAR

% vortex (central) + shear (y axis)
v0=4;%-4+8*rand; %max velocity
[x,y]=meshgrid(xvf,yvf);
[o,r]=cart2pol(x,y);
R1=300;%min(xmax/2,ymax/2)*rand; %radius
J=0.01;
uoin = (r <= R1);  % se cambio queste formule devo cambiare anche le funzioni uu e vv
uout = (r > R1);
uo = uoin+uout;
uo(uoin) =  v0*r(uoin)/R1;
uo(uout) =  v0*R1./r(uout);
uo(isnan(uo))=0;
u = -uo.*sin(o)+J*(y-ymax/2);% sign by pivlab: -
v = uo.*cos(o);%sign by pivlab: +
ufin=imcrop(u,[extrapx+1,extrapx+1,resx-1,resy-1]);
vfin=imcrop(v,[extrapx+1,extrapx+1,resx-1,resy-1]);

h=0.5; % half time step

div_f=255; % div_f=255 normalizes images in [0, 1]

I0=randi(56,[n_particles,n_imagepairs])+199; % peak intensity % [grey value] from 200 to 255
dp=1.5+2.5*rand(n_particles,n_imagepairs);% effective particle image diameter [pixel]

str_imp=num2str(n_imagepairs);
name=sprintf('ig3rkv_s_%dx%d_%s_noise_rhocost_div%d_dec%d_R1=%d_J=%f_ok',resx,resy,str_imp, div_f, dec, R1, J)


for nip=1:n_imagepairs
tic
nip
I1=zeros(ymax,xmax);
I2=zeros(ymax,xmax);

% LOCATION OF PARTICLE CENTRES

r0=[xmax/2*(-1 + 2*rand(n_particles,1)), ymax/2*(-1+2*rand(n_particles,1))];% initial particle centres

% check real velocity field
% figure
% quiver(x,y,u,v)
% xlabel('x [px]')
% ylabel('y [px]')
% title('Rankine vortex, direction')
% axis equal
% axis([-xmax/2, xmax/2,-ymax/2, ymax/2])
% grid on
% 
% int_rv=sqrt(u.^2+v.^2);
% figure
% contourf(x,y,int_rv)
% xlabel('x [px]')
% ylabel('y [px]')
% title('Rankine vortex, intensity')
% colorbar
% axis equal
% grid on

%% INTEGRATION OVER TIME (multiplication by time interval)
[o,r]=cart2pol(r0(:,1),r0(:,2));
uoin = (r <= R1);
uout = (r > R1);
uo = uoin+uout;
uo(uoin) =  v0*r(uoin)/R1;
uo(uout) =  v0*R1./r(uout);
uo(isnan(uo))=0;
vv = uo.*cos(o);% sign by pivlab: +
uu = -uo.*sin(o)+J*(r0(:,2)-ymax/2);%sign by pivlab: -

r_uv12=[r0 r0]+h*[-uu, -vv, uu, vv]; % particle centres [r1u r1v r2u r2v]

%dpnip=dp(:,nip).*ones(n_particles,xmax,ymax);

tic
for np=1:n_particles

% [o,r]=cart2pol(r0(np,1),r0(np,2));
% uoin = (r <= R1);
% uout = (r > R1);
% uo = uoin+uout;
% uo(uoin) =  v0*r(uoin)/R1;
% uo(uout) =  v0*R1./r(uout);
% uo(isnan(uo))=0;
% uu = -uo*sin(o);%by pivlab -
% vv = uo*cos(o);%by pivlab +

%     % particle centres, first exposition
%     r1u=r0(np,1)-h*uu; % horizontal component
%     r1v=r0(np,2)-h*vv; % vertical component
%     
%     % particle centres, second exposition
%     r2u=r0(np,1)+h*uu; %horizontal component
%     r2v=r0(np,2)+h*vv; %vertical component
% 
%     r_uv12=[r0(np,:); r0(np,:)]+h*[-uu, -vv; uu, vv]; % particle centres [r1u r1v;r2u r2v]

% for i=1:length(yvf)
%      for j=1:length(xvf)
%  I1(i,j)=I1(i,j)+I0(np)*exp((-(xvf(j)-r1u)^2-(yvf(i)-r1v)^2)/(1/8*dp(np)^2));
%  I2(i,j)=I2(i,j)+I0(np)*exp((-(xvf(j)-r2u)^2-(yvf(i)-r2v)^2)/(1/8*dp(np)^2));
%      end
% end


   I1=I1+I0(np,nip)*exp((-(XVF-r_uv12(np,1)).^2-(YVF-r_uv12(np,2)).^2)/(1/8*dp(np,nip)^2));
   I2=I2+I0(np,nip)*exp((-(XVF-r_uv12(np,3)).^2-(YVF-r_uv12(np,4)).^2)/(1/8*dp(np,nip)^2));

%np
end
toc

%I1=sum(I0(:,nip).*exp((-(XVFnp-r_uv12(:,1)).^2-(YVFnp-r_uv12(:,2)).^2)./(1/8*dpnip.^2)));
%I2=sum(I0(:,nip).*exp((-(XVFnp-r_uv12(:,3)).^2-(YVFnp-r_uv12(:,4)).^2)./(1/8*dpnip.^2)));


I1=imcrop(I1,[extrapx+1,extrapx+1,resx-1,resy-1]); % [XMIN YMIN WIDTH HEIGHT]
I2=imcrop(I2,[extrapx+1,extrapx+1,resx-1,resy-1]); % [XMIN YMIN WIDTH HEIGHT]

I1(I1>255)=255;
I2(I2>255)=255;

Ifin1(nip,:,:)=round(I1/div_f,dec);
Ifin2(nip,:,:)=round(I2/div_f,dec);

I1=I1+imnoise(I1,'gaussian',0,max(max(I1))/100);
I2=I2+imnoise(I2,'gaussian',0,max(max(I2))/100);


% figure
% imshow(I1, 'initialmagnification',1000)
% 
% figure
% imshow(I2,'initialmagnification',1000)

end

%% SAVING

save(name, 'Ifin1', 'Ifin2', 'ufin', 'vfin')

