clear
%close all
%clc

% images from image_generator3_rankine or image_generator3_rankine_shear (large images)
% launch after image_generator3_rankine or image_generator3_rankine_shear

size_iw=32; % size of each interrogation window
passo=1; % quiver visualization

%% networks

% net_name=["trained_net_1mlx2",... % load different networks
%     "trained_net_nocurv08",...
%     "trained_net_nocurv06_1milione",...
%     "trained_net_1milione_13806_009",...
%     "trained_net_prime100ep_11603_lr1e05",...
%     "trained_net_nc_c_1ml"];

net_name=["trained_net_1mlx2"];

%% how many image pairs?
nip_v=[1 50];

%% initializations
fn=zeros(length(net_name),length(nip_v));
rmseu=fn;
rmsev=fn;
biasu=fn;
biasv=fn;

%%
for cnn=1:length(net_name)
ig3='ig3rkv_384x192_50_noise_rhocost_div255_dec4_R1=300_ok'; % load data
load(ig3)
load(net_name(cnn)) % load net
net_name(cnn)
%%
% ufin=squeeze(ufin(1,:,:));
% vfin=squeeze(vfin(1,:,:));
% 
a=zeros(1,size(Ifin1,2),size(Ifin1,3));
a(1,:,:)=ufin(:,:);
ufin=a;

a=zeros(1,size(Ifin1,2),size(Ifin1,3));
a(1,:,:)=vfin(:,:);
vfin=a;

for nf=1:length(nip_v)

nip_sel=nip_v(nf);
Ifin1x=Ifin1(1:nip_sel,:,:);
Ifin2x=Ifin2(1:nip_sel,:,:);

%% INITIALIZATION
wholex=-size(Ifin1x,3)/2+0.5:1:size(Ifin1x,3)/2-0.5;
wholey=size(Ifin1x,2)/2-0.5:-1:-size(Ifin1x,2)/2+0.5;

whole_ureal=zeros(size(Ifin1x,2),size(Ifin1x,3));
whole_vreal=zeros(size(Ifin1x,2),size(Ifin1x,3));

whole_upred=zeros(size(Ifin1x,1),size(Ifin1x,2),size(Ifin1x,3));
whole_vpred=zeros(size(Ifin1x,1),size(Ifin1x,2),size(Ifin1x,3));
whole_int_pred=zeros(size(Ifin1x,1),size(Ifin1x,2),size(Ifin1x,3));

whole_upred_a=zeros(size(Ifin1x,2),size(Ifin1x,3)); % auxiliary variables for plot
whole_vpred_a=zeros(size(Ifin1x,2),size(Ifin1x,3));

% mean_abs_u=zeros(size(Ifin1,1),1);
% max_abs_u=zeros(size(Ifin1,1),1);
% min_abs_u=zeros(size(Ifin1,1),1);
% std_abs_u=zeros(size(Ifin1,1),1);
% 
% mean_abs_v=zeros(size(Ifin1,1),1);
% max_abs_v=zeros(size(Ifin1,1),1);
% min_abs_v=zeros(size(Ifin1,1),1);
% std_abs_v=zeros(size(Ifin1,1),1);
% 
% mean_rel_u=zeros(size(Ifin1,1),1);
% max_rel_u=zeros(size(Ifin1,1),1);
% min_rel_u=zeros(size(Ifin1,1),1);
% std_rel_u=zeros(size(Ifin1,1),1);
% 
% mean_rel_v=zeros(size(Ifin1,1),1);
% max_rel_v=zeros(size(Ifin1,1),1);
% min_rel_v=zeros(size(Ifin1,1),1);
% std_rel_v=zeros(size(Ifin1,1),1);

%% SET FOR CYCLE (split)

forin=1;
forfin=size(Ifin1x,2)*size(Ifin1x,3)/size_iw^2;

%%
for nip=1:size(Ifin1x,1) % for each image pair
whole_ureal(:,:)=squeeze(ufin);
whole_vreal(:,:)=squeeze(vfin);
whole_int_real=sqrt(whole_ureal.^2+whole_vreal.^2);

[Ifin1_split,Ifin2_split,ufin_split,vfin_split,iwx,iwy]=split(Ifin1x(nip,:,:),Ifin2x(nip,:,:),ufin,vfin,size_iw);

XTest=zeros(size(Ifin1_split,1),size_iw,size_iw,2);
XTest(:,:,:,1)=Ifin1_split;
XTest(:,:,:,2)=Ifin2_split; 

XTest=permute(XTest, [2 3 4 1]); % [resx, resy, channel, number of images]

%% PREDICT

YPred=predict(net, XTest);

%% RECONSTRUCTION OF VELOCITY FIELDS
x=-15.5:1:15.5;
y=15.5:-1:-15.5;

upred=zeros(size(Ifin1_split,1),size(Ifin1_split,2), size(Ifin1_split,3));
vpred=zeros(size(Ifin1_split,1),size(Ifin1_split,2), size(Ifin1_split,3));
ureal=zeros(size(Ifin1_split,1),size(Ifin1_split,2), size(Ifin1_split,3));
vreal=zeros(size(Ifin1_split,1),size(Ifin1_split,2), size(Ifin1_split,3));

int_pred=zeros(size(Ifin1_split,1), size(Ifin1_split,2), size(Ifin1_split,3)); % int=intensity
int_real=zeros(size(Ifin1_split,1), size(Ifin1_split,2), size(Ifin1_split,3));

int_p=zeros(size(Ifin1_split,2), size(Ifin1_split,3)); % auxiliary variable
int_r=zeros(size(Ifin1_split,2), size(Ifin1_split,3)); % auxiliary variable

for k=forin:forfin
upredf= @(xx,yy) YPred(k,1)+YPred(k,[3,4])*[xx;yy]; % predicted velocity field
vpredf= @(xx,yy) YPred(k,2)+YPred(k,[5,6])*[xx;yy];

for i=1:length(x)
    for j=1:length(y)
upred(k,j,i)=upredf(x(i),y(j));
vpred(k,j,i)=vpredf(x(i),y(j));

int_pred(k,j,i)=sqrt(upred(k,j,i).^2+vpred(k,j,i).^2);
int_real(k,j,i)=sqrt(ufin_split(k,j,i).^2+vfin_split(k,j,i).^2);
    end
end

end

%% VISUALIZATION OF VELOCITY FIELDS (EACH INTERROGATION WINDOW)

% for k=forin:2%forfin
%     % predicted direction
%     up(:,:)=upred(k,:,:); % auxiliary variable
%     vp(:,:)=vpred(k,:,:); % auxiliary variable
%     figure('units','normalized','outerposition',[0 0 1 1])
%     subplot(2,2,1)
%     quiver(x, y, up(:,:), vp(:,:))
%     xlabel('x [px]')
%     ylabel('y [px]')
%     axis([min(x),max(x),min(y),max(y)])
%     title('Prediction, direction')
%     grid on
%     
%     % true field, direction
%     up(:,:)=ufin(k,:,:);
%     vp(:,:)=vfin(k,:,:);
%     subplot(2,2,2)
%     quiver(x, y, up(:,:), vp(:,:))
%     xlabel('x [px]')
%     ylabel('y [px]')
%     axis([min(x),max(x),min(y),max(y)])
%     title('True field, direction')
%     grid on
%     
%     int_p(:,:)=int_pred(k,:,:);
%     int_r(:,:)=int_real(k,:,:);
%     
%     bottom = min(min(min(int_p)),min(min(int_r)));
%     top  = max(max(max(int_p)),max(max(int_r)));
%     
%     % predicted intensity
%     subplot(2,2,3)
%     contourf(x,y,int_p)
%     xlabel('x [px]')
%     ylabel('y [px]')
%     axis([min(x),max(x),min(y),max(y)])
%     title('Prediction, intensity')
%     caxis manual
%     caxis([bottom top]);
%     colorbar
%     grid on
% 
%     % true field, intensity
%     subplot(2,2,4)
%     contourf(x,y,int_r)
%     xlabel('x [px]')
%     ylabel('y [px]')
%     axis([min(x),max(x),min(y),max(y)])
%     title('True field, intensity')
%     caxis manual
%     caxis([bottom top]);
%     colorbar
%     grid on
%     
% end

%% RECOMPOSE  WHOLE IMAGES

niw=1;
for i=1:iwy
    for j=1:iwx
whole_upred(nip,1+(i-1)*size_iw:size_iw+(i-1)*size_iw,1+(j-1)*size_iw:size_iw+(j-1)*size_iw)=upred(niw,:,:);
whole_vpred(nip,1+(i-1)*size_iw:size_iw+(i-1)*size_iw,1+(j-1)*size_iw:size_iw+(j-1)*size_iw)=vpred(niw,:,:);
whole_int_pred(nip,1+(i-1)*size_iw:size_iw+(i-1)*size_iw,1+(j-1)*size_iw:size_iw+(j-1)*size_iw)=int_pred(niw,:,:);

niw=niw+1; % for each interrogation window
    end
end

%% VISUALIZATION OF EACH WHOLE IMAGE
% predicted direction
whole_upred_a(:,:)=whole_upred(nip,:,:);
whole_vpred_a(:,:)=whole_vpred(nip,:,:);

% % figure('units','normalized','outerposition',[0 0 1 1])
% % title('whole image')
% % 
% % subplot(2,2,1)
% % quiver(wholex(1:passo:end), wholey(1:passo:end), whole_upred_a(1:passo:end,1:passo:end), whole_vpred_a(1:passo:end,1:passo:end))
% % xlabel('x [px]')
% % ylabel('y [px]')
% % axis([min(wholex),max(wholex),min(wholey),max(wholey)])
% % title('Prediction, direction')
% % grid on
% % 
% % % true field, direction
% % subplot(2,2,2)
% % quiver(wholex(1:passo:end), wholey(1:passo:end), whole_ureal(1:passo:end, 1:passo:end), whole_vreal(1:passo:end,1:passo:end))
% % xlabel('x [px]')
% % ylabel('y [px]')
% % axis([min(wholex),max(wholex),min(wholey),max(wholey)])
% % title('True field, direction')
% % grid on
% % 
% % bottom = min(min(min(min(int_pred))),min(min(min(int_real))));
% % top  = max(max(max(max(int_pred))),max(max(max(int_real))));
% % 
% % % predicted intensity
% % whole_upred_a(:,:)=whole_int_pred(nip,:,:);
% % 
% % subplot(2,2,3)
% % contourf(wholex,wholey,whole_upred_a)
% % xlabel('x [px]')
% % ylabel('y [px]')
% % axis([min(wholex),max(wholex),min(wholey),max(wholey)])
% % title('Prediction, intensity')
% % caxis manual
% % caxis([bottom top]);
% % colorbar
% % grid on
% % 
% % % true field, intensity
% % subplot(2,2,4)
% % contourf(wholex,wholey,whole_int_real)
% % xlabel('x [px]')
% % ylabel('y [px]')
% % axis([min(wholex),max(wholex),min(wholey),max(wholey)])
% % title('True field, intensity')
% % caxis manual
% % caxis([bottom top]);
% % colorbar
% % grid on

%% relative and absolute ERRORS
% abserr=abs(whole_upred-whole_ureal);
% mean_abs_u(nip)=mean(mean(abserr));
% max_abs_u(nip)=max(max(abserr));
% min_abs_u(nip)=min(min(abserr));
% std_abs_u(nip)=std(reshape(abserr, [1,size(abserr,1)*size(abserr,2)]));
% 
% abserr=abs(whole_vpred-whole_vreal);
% mean_abs_v(nip)=mean(mean(abserr));
% max_abs_v(nip)=max(max(abserr));
% min_abs_v(nip)=min(min(abserr));
% std_abs_v(nip)=std(reshape(abserr, [1,size(abserr,1)*size(abserr,2)]));
% 
% relerr=abs(whole_upred-whole_ureal)./abs(whole_ureal);
% mean_rel_u(nip)=mean(mean(relerr));
% max_rel_u(nip)=max(max(relerr));
% min_rel_u(nip)=min(min(relerr));
% std_rel_u(nip)=std(reshape(relerr, [1,size(abserr,1)*size(abserr,2)]));
% 
% relerr=abs(whole_vpred-whole_vreal)./abs(whole_vreal);
% mean_rel_v(nip)=mean(mean(relerr));
% max_rel_v(nip)=max(max(relerr));
% min_rel_v(nip)=min(min(relerr));
% std_rel_v(nip)=std(reshape(relerr, [1,size(abserr,1)*size(abserr,2)]));

%nip
end

%% ERRORS
% N=size_iw*size_iw; % number of grid points
% 
% abserr_u=whole_upred-ufin;
% abserr_v=whole_vpred-vfin;
% 
% frobeniusnorm=sqrt(1/N*sum(sum(mean(abserr_u,1).^2+mean(abserr_v,1).^2)))
% 
% rmseu=sqrt(1/N*sum(sum(mean(abserr_u,1).^2)))
% rmsev=sqrt(1/N*sum(sum(mean(abserr_v,1).^2)))
% 
% biasu=1/N*sqrt(sum(sum(mean(abs(abserr_u),1))))
% biasv=1/N*sqrt(sum(sum(mean(abs(abserr_v),1))))



%% MEAN OF ALL THE IMAGES (ok if all the images related to the same velocity field) 
passo=10;
upred_mean=squeeze(mean(whole_upred,1));
vpred_mean=squeeze(mean(whole_vpred,1));
intpred_mean=sqrt(upred_mean.^2+vpred_mean.^2);

figu=figure('units','normalized','outerposition',[0 0 1 1]);
sgtitle(['mean field of ', num2str(nip_sel)])
% 
% predicted direction
subplot(2,2,1)
quiver(wholex(1:passo:end), wholey(1:passo:end), upred_mean(1:passo:end,1:passo:end), vpred_mean(1:passo:end,1:passo:end))
xlabel('x [px]')
ylabel('y [px]')
axis([min(wholex),max(wholex),min(wholey),max(wholey)])
title('mean prediction, direction')
grid on

% true field, direction
subplot(2,2,2)
quiver(wholex(1:passo:end), wholey(1:passo:end), whole_ureal(1:passo:end, 1:passo:end), whole_vreal(1:passo:end,1:passo:end))
xlabel('x [px]')
ylabel('y [px]')
axis([min(wholex),max(wholex),min(wholey),max(wholey)])
title('True field, direction')
grid on

bottom = min(min(min(min(int_pred))),min(min(min(int_real))));
top  = max(max(max(max(int_pred))),max(max(max(int_real))));

% predicted intensity
whole_upred_a(:,:)=whole_int_pred(nip,:,:);

subplot(2,2,3)
contourf(wholex,wholey,intpred_mean)
xlabel('x [px]')
ylabel('y [px]')
axis([min(wholex),max(wholex),min(wholey),max(wholey)])
title('mean prediction, intensity')
caxis manual
caxis([bottom top]);
colorbar
grid on

% true field, intensity
subplot(2,2,4)
contourf(wholex,wholey,whole_int_real)
xlabel('x [px]')
ylabel('y [px]')
axis([min(wholex),max(wholex),min(wholey),max(wholey)])
title('True field, intensity')
caxis manual
caxis([bottom top]);
colorbar
grid on

%% ERRORS ON THE MEAN IMAGE 

N=size(upred_mean,1)*size(upred_mean,2);
abserr_u=upred_mean-squeeze(ufin(1,:,:));
abserr_v=vpred_mean-squeeze(vfin(1,:,:));

fn(cnn,nf)=sqrt(1/N*sum(sum(abserr_u.^2+abserr_v.^2)));

rmseu(cnn,nf)=sqrt(1/N*sum(sum(abserr_u.^2)));
rmsev(cnn,nf)=sqrt(1/N*sum(sum(abserr_v.^2)));

biasu(cnn,nf)=1/N*sqrt(sum(sum(abs(abserr_u),1)));
biasv(cnn,nf)=1/N*sqrt(sum(sum(abs(abserr_v),1)));

%%
if strfind(ig3,'rkv_s')
    benchmark_name='rkv_s';
else
    benchmark_name='rkv';
end

name=sprintf('test2_%d_%dx%d_%s_%s', size(Ifin1x,1), size(Ifin1x,3), size(Ifin1x,2), benchmark_name, net_name(cnn));
%saveas(figu, '768x384_500','png')

save(name, 'upred_mean', 'vpred_mean')

end

end

%% PLOT

figure
for cnn=1:length(net_name)
hold on
p=plot(nip_v,fn(cnn,:));
p.Marker='*';
xlabel('image pairs')
ylabel('Frobenius norm')
grid on
axis([min(nip_v),max(nip_v),0,max(max(fn))])
end
legend('nocurv 1e06 200 06','nocurv 4e05 100 08','nocurv 1e06 100 06','compl 1e06 100 09','compl 4e05 100 12','nocurv+compl 1e06 100+100 09', 'location','northeast');

figure
for cnn=1:length(net_name)
subplot(1,2,1)
hold on
p=plot(nip_v,rmseu(cnn,:));
p.Marker='*';
xlabel('image pairs')
ylabel('RMSE(v)')
grid on
axis([min(nip_v),max(nip_v),0,max(max(max(rmseu),max(max(rmsev))))])
end
legend('nocurv 1e06 200 06','nocurv 4e05 100 08','nocurv 1e06 100 06','compl 1e06 100 09','compl 4e05 100 12','nocurv+compl 1e06 100+100 09', 'location','northeast');
for cnn=1:length(net_name)
subplot(1,2,2)
hold on
p=plot(nip_v,rmsev(cnn,:));
p.Marker='*';
xlabel('image pairs')
ylabel('RMSE(u)')
grid on
axis([min(nip_v),max(nip_v),0,max(max(max(rmseu),max(max(rmsev))))])
end

figure
for cnn=1:length(net_name)
subplot(1,2,1)
hold on
p=plot(nip_v,biasu(cnn,:));
p.Marker='*';
xlabel('image pairs')
ylabel('bias(u)')
grid on
axis([min(nip_v),max(nip_v),0,max(max(max(biasu),max(max(biasv))))])
end
legend('nocurv 1e06 200 06','nocurv 4e05 100 08','nocurv 1e06 100 06','compl 1e06 100 09','compl 4e05 100 12','nocurv+compl 1e06 100+100 09', 'location','northeast');
for cnn=1:length(net_name)
subplot(1,2,2)
hold on
p=plot(nip_v,biasv(cnn,:));
p.Marker='*';
xlabel('image pairs')
ylabel('bias(v)')
grid on
axis([min(nip_v),max(nip_v),0,max(max(max(biasu),max(max(biasv))))])
end

