function[]= train_cnn_piv4()
clear
close all
clc
% Matlab 2019b required

%% LOAD AND REARRANGE DATA
% training data
inputData=fileDatastore(fullfile('inputData', 'train'),'ReadFcn',@load,'FileExtensions','.mat');
targetData=fileDatastore(fullfile('targetData','train'),'ReadFcn',@load,'FileExtensions','.mat');
inputDatat = transform(inputData,@(data) rearrange_input(data));
targetDatat = transform(targetData,@(data) rearrange_target(data));

trainData=combine(inputDatat,targetDatat);

% validation data
inputData=fileDatastore(fullfile('inputData', 'val'),'ReadFcn',@load,'FileExtensions','.mat');
targetData=fileDatastore(fullfile('targetData','val'),'ReadFcn',@load,'FileExtensions','.mat');
inputDatat = transform(inputData,@(data) rearrange_input(data));
targetDatat = transform(targetData,@(data) rearrange_target(data));

valData=combine(inputDatat,targetDatat);
%% CREATE NETWORK

%scale=0.01;

Layers = [
    imageInputLayer([32 32 2],"Name","imageinput")
    convolution2dLayer([16 16],512,"NumChannels", 2, "Padding","same","Stride",[8 8]);%, 'WeightsInitializer',@(sz) leakyHe(sz,scale))
    batchNormalizationLayer()
    leakyReluLayer(0.1)
    averagePooling2dLayer([5 5],"Padding","same")
    leakyReluLayer(0.1)
    %dropoutLayer(0.5)
    %batchNormalizationLayer() : no! after fully and before non linearity
    %(usually)
    %leakyReluLayer(0.1)
    fullyConnectedLayer(8192)
    %fullyConnectedLayer(512)
    leakyReluLayer(0.1)
    %dropoutLayer(0.5)
    fullyConnectedLayer(4096)
    %fullyConnectedLayer(128)
    leakyReluLayer(0.1)
    %dropoutLayer(0.5)
    fullyConnectedLayer(2048)
    %fullyConnectedLayer(32)
    %reluLayer("Name","relu")
    preluLayer(2048,'prelu')
    %preluLayer(32,'prelu')
    %dropoutLayer(0.5)
    %fullyConnectedLayer(1);
    fullyConnectedLayer(6);
    aeRegressionLayer('output')];
    %regressionLayer];

%     dropoutLayer(0.5)

%Layer(12)=setL2Factor(Layers(12),'Alpha',2);
%getL2Factor(layer(10),'Alpha')
%factor = getL2Factor(layers(4),'Alpha');

%     maeRegressionLayer('output')];      
%    regressionLayer("Name","regressionOutput")];


%% UNCOMMENT TO LOAD A NET PREVIOUSLY TRAINED AND TO CONTINUE TRAINING
% load trained_net
% Layers=net.Layers;
% clear net

%% DEFINE TRAINING OPTIONS
options = trainingOptions('adam',...
     'ExecutionEnvironment','gpu',...
     'MaxEpochs', 100,...
     'Minibatchsize', 128,...
     'InitialLearnRate',1e-5,...
     'LearnRateSchedule', 'none',...
     'L2Regularization', 0.05,...
     'Validationdata', valData,...
     'ValidationFrequency',14000,...
     'Shuffle','never',...
     'Verbose',true);

%% CHECK GPU
conto=gpuDeviceCount
selezione=gpuDevice

%% TRAIN
tic
net=trainNetwork(trainData, Layers, options);
toc
%% PREDICTION ON VALIDATION SET
YPred = predict(net,inputDatat);

%%
save('trained_net', 'options','Layers', 'net')

%%
targetData=fileDatastore(fullfile('targetData', 'val'),'ReadFcn',@load,'FileExtensions','.mat');
targetDatat = transform(targetData,@(data) rearrange_target2(data));

%%
abserr = abs(YPred-readall(targetDatat));
mean_abserr=mean(abserr,1)
std_abserr=std(abserr,0,1)
max_abserr=max(abserr)
min_abserr=min(abserr)

relerr=(abserr)./abs(readall(targetDatat));
mean_relerr=mean(relerr,1)
std_relerr=std(relerr,0,1)
max_relerr=max(relerr)
min_relerr=min(relerr)

rmse=sqrt(sum(mean(abserr.^2))) % cos  come matlab calcola l'rsme error che vedo durante il training

end
%% PREDICTION ON TRAINING SET
% YPred = predict(net,XTrain);
% 
% abserr = abs(YPred-YTrain);
% mean_abserr=mean(abserr,1)
% std_abserr=std(abserr,0,1)
% max_abserr=max(abserr)
% min_abserr=min(abserr)
% 
% relerr=(abserr)./abs(YTrain);
% mean_relerr=mean(relerr,1)
% std_relerr=std(relerr,0,1)
% max_relerr=max(abserr)
% min_relerr=min(abserr)

%% FUNCTIONS

% function weights = leakyHe(sz,scale)
% 
% % If not specified, then use default scale = 0.1
% if nargin < 2
%     scale = 0.1;
% end
% 
% filterSize = [sz(1) sz(2)];
% numChannels = sz(3);
% numIn = filterSize(1) * filterSize(2) * numChannels;
% 
% varWeights =0.000001/numIn;%0.000003/numIn;% 0.0001 / ((1 + scale^2) * numIn); 
% weights = randn(sz)* sqrt(varWeights);
% end

function image = rearrange_input(data)
image=data.C;
image= {image};
end

function image = rearrange_target(data)
image=data.Vfin;
image= {image};
end

function image = rearrange_target2(data)
image=data.Vfin;
end
